# pydistinto - a Python implementation of different measures of distinctiveness for contrastive text analysis

[![DOI](https://zenodo.org/badge/384188711.svg)](https://zenodo.org/badge/latestdoi/384188711)

**pydistinto is a further development of [pyzeta](https://github.com/cligs/pyzeta)**

## What is the purpose?

To facilitate the use of relevant measures that can be used for contrastive text analysis, we are developing a tool written in Python called `pydistinto` as part of the [Zeta and Company](https://zeta-project.eu/en/) project. The goal of our project is to achieve a deeper understanding of the different measures of distinctiveness and to propose improvements for their implementation and use. For this purpose, we created a [conceptual framework](http://doi.org/10.5281/zenodo.5092328) of different measures of distinctiveness. Based on the framework and Codes from [pyzeta](https://github.com/cligs/pyzeta), pydistinto has been developed.

## Getting help

* The `data` folder contains some examples of what input pydistinto needs and the `working_dir` folder contains what output it produces
* The `howto.md` file contains a brief tutorial of sorts for running analyses with pydistinto.

## Requirements and installation

* Requirements: Python 3 with pandas, numpy, sklearn, pygal, spacy
